<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "insurance_file_stats".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "InsuranceFileStats".
 *
 * Columns in table "insurance_file_stats" available as properties of the model,
 * followed by relations of table "insurance_file_stats" available as properties of the model.
 *
 * @property integer $id
 * @property integer $insurance_file_id
 * @property string $event_type
 * @property integer $event_row
 * @property string $event_reason
 * @property string $date_added
 *
 * @property InsuranceFile $insuranceFile
 */
abstract class BaseInsuranceFileStats extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'insurance_file_stats';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'InsuranceFileStats|InsuranceFileStats', $n);
    }

    public static function representingColumn()
    {
        return 'event_type';
    }

    public function rules()
    {
        return array(
            array('insurance_file_id, event_type, date_added', 'required'),
            array('insurance_file_id, event_row', 'numerical', 'integerOnly'=>true),
            array('event_type', 'length', 'max'=>7),
            array('event_reason', 'safe'),
            array('event_row, event_reason', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, insurance_file_id, event_type, event_row, event_reason, date_added', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'insuranceFile' => array(self::BELONGS_TO, 'InsuranceFile', 'insurance_file_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'insurance_file_id' => null,
            'event_type' => Yii::t('app', 'Event Type'),
            'event_row' => Yii::t('app', 'Event Row'),
            'event_reason' => Yii::t('app', 'Event Reason'),
            'date_added' => Yii::t('app', 'Date Added'),
            'insuranceFile' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->join = false;
        $criteria->compare('id', $this->id);
        $criteria->compare('insurance_file_id', $this->insurance_file_id);
        $criteria->compare('event_type', $this->event_type, true);
        $criteria->compare('event_row', $this->event_row);
        $criteria->compare('event_reason', $this->event_reason, true);
        $criteria->compare('date_added', $this->date_added, false);
        $criteria->select = 'insurance_file_id, event_type, event_row, event_reason';


        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}